<template>
  <ul
    class="ces_filter_container"
    ref="filterContainer"
    v-if="filterList && filterData && filterToggle"
    v-show="show"
  >
    <li v-for="(item, index) in filterList" :key="'f_l_' + index">
      <div class="ces_filter_name">
        <span v-text="item.name + '：'"></span>
      </div>
      <ul class="ces_filter_data">
        <li
          v-for="(v, i) in item.data"
          :key="'f_l_d_' + index + '_' + i"
          v-show="filterToggle[item.prop] || i < filterLength"
          :style="{
            'margin-top': i < filterLength ? '0' : '10px',
          }"
        >
          <a
            class="text_clip"
            :class="{ current: isCurrentFilter(item.prop, v) }"
            @click.prevent="selectFilter(item.prop, v)"
          >
            <el-tooltip
              effect="dark"
              :content="v.name"
              placement="top"
            >
              <span v-text="v.name"></span>
            </el-tooltip>
          </a>
        </li>

        <div
          class="toggle_bar"
          v-if="item.data.length > filterLength"
          @click="filterToggleAction(item.prop)"
        >
          <span>{{ filterToggle[item.prop] ? "收起" : "展开" }}</span>
          <i
            :class="
              filterToggle[item.prop]
                ? 'el-icon-caret-bottom'
                : 'el-icon-caret-top'
            "
          ></i>
        </div>
      </ul>
    </li>
  </ul>
</template>

<script>
export default {
  props: {
    filterList: {
      type: Array,
      default: [],
    },
    show: {
      type: Boolean,
      default: false,
    },
  },
  data: () => ({
    filterData: null, // 筛选条件
    filterToggle: null, // 控制筛选条件的展开和收起
    filterLength: 0, // 每行最多可容纳多少个过滤条件
  }),
  watch: {
    filterList: {
      handler(val) {
        this.initFilterData();
      },
      deep: true,
    },
    show(value) {
      if (value) {
        this.getFilterLength();
      }
    },
  },
  methods: {
    initFilterData() {
      if (this.filterList && this.filterList.length) {
        this.filterData = {};
        this.filterToggle = {};
        this.filterList.forEach((item) => {
          this.$set(this.filterData, item.prop, []);
          this.$set(this.filterToggle, item.prop, false);
        });
      }
    },
    getFilterLength() {
      if (this.show) {
        this.$nextTick(() => {
          let width =
            this.$refs.filterContainer.getBoundingClientRect().width -
            20 * 2 - // 两侧padding
            100 - // 左侧标题
            20 - // 距左侧标题的边距
            110; // 折叠按钮的宽度

          this.filterLength = Math.floor(width / 150);
          // console.log("每行最多可容纳" + this.filterLength + "个filter");
        });
      }
    },
    filterToggleAction(prop) {
      this.$set(this.filterToggle, prop, !this.filterToggle[prop]);
    },
    isCurrentFilter(prop, filter) {
      return (
        this.filterData &&
        this.filterData[prop] &&
        this.filterData[prop].indexOf(filter) > -1
      );
    },
    selectFilter(prop, filter) {
      if (this.isCurrentFilter(prop, filter)) {
        this.filterData[prop].splice(this.filterData[prop].indexOf(filter), 1);
      } else {
        this.filterData[prop].push(filter);
      }

      this.$emit("filter-change", this.filterData);
    },
  },
  mounted() {
    this.initFilterData();

    window.addEventListener("resize", this.getFilterLength);
  },
  destroyed() {
    window.removeEventListener("resize", this.getFilterLength);
  },
};
</script>

<style scoped>
.ces_filter_container {
  padding: 14px 19px;
  border: 1px solid #e3e5ef;
  border-radius: 6px;
  margin-top: 10px;
}
.ces_filter_container > li {
  display: flex;
  justify-content: flex-start;
  align-items: flex-start;
  padding-top: 12px;
}
.ces_filter_name {
  width: 100px;
  height: 30px;
  flex-shrink: 0;
  text-align: right;
  font-size: 14px;
  line-height: 30px;
  font-weight: bold;
  color: #1a2236;
}
.ces_filter_data {
  width: calc(100% - 120px);
  min-height: 42px;
  padding-right: 110px;
  box-sizing: border-box;
  margin-left: 20px;
  flex-grow: 1;
  display: inline-flex;
  flex-wrap: wrap;
  justify-content: flex-start;
  align-items: flex-start;
  padding-bottom: 11px;
  position: relative;
}
.ces_filter_container > li:not(:last-child) > .ces_filter_data {
  border-bottom: 1px solid #e9ecf3;
}
.ces_filter_data > li {
  flex-shrink: 0;
  padding-right: 20px;
}
.ces_filter_data > .toggle_bar {
  height: 30px;
  position: absolute;
  top: 0;
  right: 0;
  font-size: 14px;
  line-height: 30px;
  color: #0f2683;
  cursor: pointer;
}
.ces_filter_data > li > a {
  display: block;
  height: 30px;
  width: 130px;
  padding: 0 15px;
  box-sizing: border-box;
  border-radius: 12px;
  text-align: center;
  cursor: pointer;
  font-size: 14px;
  line-height: 30px;
  color: #58617a;
}
.ces_filter_data > li > a.current {
  background-color: #515fe7;
  color: #f4f7fc;
}
</style>
